/* BACK-SPACE NOV 1998 */
/* Compile this with Turbo-C command line:  tcc -ml fdscroll.c */

#include <stdio.h>
#include<dos.h>
#include<io.h>
#include<fcntl.h>

extern  char    *malloc();
extern  long    atol();

#define NULL 0L
#define OK   0
#define ERROR   (-1)

#define BREAK   0X03    /* CTRL-C */
#define CTRLB   0X02    /* CTRL-B */
#define CTRLZ   0X1A    /* CTRL-Z */
#define CTRLQ   0X11    /* CTRL-Q */

/*      Unsolicited keyboard input */
#define DOS_ATTN        (0X00FF & bdos(0X06,0XFF, 0))
#define BRAKE   BREAK == DOS_ATTN /* STOP ! */

#define MAXLINE 0X100
#define MAX_FILES       0X40
#define V_NR    25
#define V_NC    80

#define N_CHARS 95
#define F_NR    24
#define F_NCMAX 53
#define F_WB    24
#define SR_NC  140
#define FONT_NBYTES     F_NR * F_NCMAX
#define FX_SIZE sizeof(struct h_font)+FONT_NBYTES
#define FMAP(X) (((BYTE*)(X)) + sizeof(struct h_font))
#define SR_SIZE F_NR * SR_NC

#define IRAND(X)        (rand()%(X))

typedef unsigned char BYTE;     /* unsigned 1 byte data */
typedef long int      LONG;     /* delay time on fast computers */

struct SDESC {                  /* standard string - maybe arabic */
        BYTE *ADDR;
        unsigned SDLEN;
        };

typedef struct SDESC * SLICE;

struct  h_font {int nr; int nc;};

typedef struct h_font *FONT;
FONT    alpha[96];
BYTE    shift_mat[F_NR * SR_NC];
BYTE    linbuf[MAXLINE];
int     h_rule[F_NCMAX];
int     qv = 0;         /* verbose */
int     q_crunch = 1;   /* crunch bmultiple blanks */
LONG    n_wait = 0;

struct  scroll_cmd {
        int     sc_attr;
        int     sc_cycle;    /* wait time before new lut */
        int     sc_erode;
        int     sc_flip;
        char   *sc_line;
        char   *sc_perm;
        char   *sc_cmap;
        char   *sc_lut;
        char   *sc_fn;
        struct  SDESC   sc_data;
        } xx[MAX_FILES];


typedef struct scroll_cmd *SCMD;

#define FLIP_SCREEN     0X01    /* flip screen */
#define FLIP_GLYPH      0X02    /* flip glyph */

BYTE   *vram = (BYTE*) 0XB8000000L;     /* video ram */
BYTE   *vs   = NULL;    /* virtual screen */

char   *version_string="fdscroll 21/11/1998 03:47:22";
char   *sc_font = "euro_3.raw";
char   *sc_list = "scroll.ini";
char   *font_file = NULL;

char    *usage_text[] = {
    "fdscroll {f=font_file} {x=} parameter_file",
    "f=   file name     font file raw data",
    "{x=} file name     list of files to scroll."
    "     this has same format as a list of 'scroll' commands",
    NULL
    };

#define MAX_LUT 16
#define LUT_SIZE 16

char   *lut_tab[] = {
    " 123456789ABCDEF",         /* default */
    " WRQ80&3C7v+~^.N",
    " WQ8S0&3Coci;:.N",
    " .^~+v7C3&08QRWN",
    " .:;icoC3&0S8QWN",
    ".123456789ABCDEF",
    " W^Q+073C&v8~R.N",
    " 3.&^0~8+QvR7WCN",
    " WRQ 0 3 7 + ^.N",
    " W  8 & C v ~ .N",
    " WR 8  3 7v+ ^ N",
    " WRQ80 3 7v ~  N",
    " MPQ6o/EDiu=-:,N",
    " +.,;'|$/\=_().-",
    " ۰۰۰",
    " "
    };


/*      initial structure */

struct  scroll_cmd sc_nul = {
        -1, 0, 0, 0,
        NULL,
        NULL,
        NULL,
        NULL,
        NULL,           /* file */
       {NULL,0},        /* data */
        };

main(argc, argv)
int argc;
char **argv;

{
FILE   *fp;
char   *cmd_file  = sc_list;
char   *s;
int     rc, j, nc = 0, nfiles = 0;
LONG    nbytes = 0;
for(argv++, argc--; 0 < argc--; argv++) {
    s = *argv;
    if (s[1] == '=') switch(s[0]) {
        case 'D':       /* delay */
        case 'd':  n_wait = atol(s+2);
        break;
        case 'F':   /* font */
        case 'f': font_file = s+2;
        break;
        case 'X':   /* commands */
        case 'x': cmd_file = s+2;
        break;
        case 'v':       /* verbose    */
        case 'V':  qv = 1;
        break;
        case 'b':       /* crunch blanks */
        case 'B':  q_crunch = atoi(s+2);
        break;
        default: break;
        }
    else cmd_file = s;
    }

/*      initialise      */

for (j = 0; j < MAX_FILES; j++) {
    xx[j] = sc_nul;
    xx[j].sc_lut = lut_tab[0];
    }

if (0 >= (nc = sc_getcmd(xx, cmd_file))) {
    printf("bad cmd_file =%s\n", cmd_file);
    return ERROR;
    }

if (font_file == NULL) font_file = sc_font;

printf("initialising font %s\n", font_file);
if (get_font(alpha, font_file))    die("bad font file");
if (NULL ==(vs = malloc(SR_SIZE))) die("memory allocation");

for (nfiles = j = 0; j < nc; j++) {
    if (xx[j].sc_fn) printf("caching ... %s\n", xx[j].sc_fn);
    if (OK == sc_zload(&xx[j].sc_data, xx[j].sc_fn)) {
        nfiles++;
        nbytes += (LONG) xx[j].sc_data.SDLEN;
        }
    }
printf("%4.4d files, %8.8ld bytes, delay=%8.8ld\n", nfiles, nbytes, n_wait);
printf("crunch = %d\n", q_crunch);

j = get_video_mode();
vram = (j == 7) ? (BYTE*) 0XB0000000L : (BYTE*) 0XB8000000L;

for (j = 0; j < nc;) {
    rc = do_cscroll(&xx[j]);
    if (rc == CTRLQ) break;
    j++;
    if (j == nc) j = 0;
    }
return OK;
}

die(char *str)
{
printf("error: %s\n", str);
exit(1);
}

sc_getcmd(dst, fn)
SCMD    dst;
char   *fn;
{
FILE   *fd = fopen(fn, "r");
BYTE   *memchr();
char   *malloc();
char   *s, *t;
int     k;
int     nfiles = 0;
if (fd == NULL) return ERROR;
while (nfiles < MAX_FILES &&
        NULL != (s = fgets(linbuf, MAXLINE, fd))) {
        t = memchr(s, '\n', MAXLINE);
        k = (t == NULL) ? MAXLINE-1 : t - s;
        s[k] = 0;
        if (NULL ==(dst->sc_line = malloc(k+1))) {
            fclose (fd);
            return ERROR;
            }
        strcpy(dst->sc_line, linbuf);
        sc_parse(dst);
        nfiles++;
        dst++;
        }
fclose (fd);
return  nfiles;
}

sc_parse(scmd)
SCMD    scmd;
{
char   *s = scmd->sc_line;
char   *var;
int     c, mode;

if (qv) printf("%s\n", s);

for (mode = 0; c = *s; s++)
    switch (2*mode + (c == ' ')) {
        case 0: var  = s;
                mode = 1;
                break;
        case 3: *s = 0;
                sc_getopt(scmd, var);
                mode = 0;
                break;
        default: break;
        }
if (mode) sc_getopt(scmd, var);
return  OK;
}

sc_getopt(dst, var)    /* fill in a structure field of dst */
SCMD    dst;
char   *var;
{
char   *hex_to_j16();
char   *s, *t;
int     i, j;
if (strlen (var) < 3 || var[1] != '=') return OK;
switch(var[0]) {
    case 'b':   /* crunch blanks */
    case 'B': q_crunch = atoi(s+2);
        break;
    case 'F':   /* define font in this file */
    case 'f': sc_font = var+2;
        break;
    case 'S':   /* source text */
    case 's': dst->sc_fn = var+2;
        break;
    case 'L':   /* lookup table */
    case 'l': dst->sc_lut =  var+2;
        break;
    case 'D':       /* delay */
    case 'd':  n_wait = atol(var+2);
        break;
    case 'E':       /* erode */
    case 'e':  dst->sc_erode = atoi(var+2);
        break;
    case 'A':       /* attribute or colour */
    case 'a':  dst->sc_attr = atoi(var+2);
        break;
    case 'J':       /* select lut */
    case 'j':  j = atoi(var+2);
               if (j < MAX_LUT) dst->sc_lut = lut_tab[j];
        break;
    case 'T':       /* Cycle lut */
    case 't':  for (t = s = var+2; *s && *s != '#'; s++);
               if (*s == 0) break;
               *s = 0;
               dst->sc_cycle = atoi(t);
               dst->sc_cmap  = hex_to_j16(s+1);
        break;
    case 'P':       /* Permute lut */
    case 'p':  if (16 == strlen(var+2)) dst->sc_perm = hex_to_j16 (var+2);
        break;
    case 'm':   /* movement */
    case 'M':   j = *(var+2);
            if (j == '-' || j== 'L' || j == 'l') dst->sc_flip |= FLIP_SCREEN;
                j = *(var+3);
            if (j == '-' || j== 'L' || j == 'l') dst->sc_flip |= FLIP_GLYPH;
    default: break;
    }
return OK;
}

char   *hex_to_j16(char *str)
{
extern  char *malloc();
char   *dst, *s, *t;
int     nc = strlen(str);
int     c, j;

if (NULL == (dst = (char*) malloc(nc+1))) return NULL;
for (t = dst, s = str, j = nc; 0 < j--; s++, t++) {
    c = *s;
    *t = 16 + (9 * (c > '@'))+ (0X0F & c);
    }
dst[nc] = 0;
return dst;
}

do_cscroll(SCMD xx)
{
if (xx->sc_attr != -1) vdu_set_attr(xx->sc_attr);

ww_puts(" ", 0, 0, 80);
ww_puts(xx->sc_fn, 0, 60, 20);

return (xx->sc_cmap == NULL)
  ? ss_scroll (alpha, xx)
  : ss_xscroll(alpha, xx);
}

get_font(FONT *abc, char *fn)
{
extern char   *malloc();
FONT    fx_crunch();
FONT    fx;
int     fd;
BYTE   *cbuf;
int     i, cnt_op;
fd = open(fn, O_BINARY | O_RDONLY);
if (fd == ERROR) return ERROR;
cbuf = malloc(FONT_NBYTES);
if (cbuf == NULL) return ERROR;
for (i = 0; i < N_CHARS; i++) {
      cnt_op = read(fd, cbuf, FONT_NBYTES);
      fx = fx_crunch(i+32, cbuf);
      if (fx == NULL) die("malloc(..font..)\n");
      abc[i] = fx;
      }
close(fd);
free(cbuf);
return OK;
}

FONT fx_crunch(int k, BYTE *src)
{
extern char   *malloc();
FONT    fx;
BYTE   *s, *t;
int     nc, i, j;
int     drop_a, drop_b;

fx = (FONT) malloc (FX_SIZE);
if (fx == NULL) return NULL;
memset(FMAP(fx), 0, FONT_NBYTES);

fx->nr = F_NR;
fx->nc = F_NCMAX;
for(s = src, j = 0; j < F_NCMAX; h_rule[j++] = 0);
for(i = F_NR; 0 < i--; )
    for(j = 0; j < F_NCMAX; j++, s++)
        h_rule[j] |= (*s != 0);


if (k == ' ') {
    fx->nc = F_WB;
    }
else {          /* trim */
    for (drop_a = j = 0; j < F_NCMAX && 0 == h_rule[j]; j++)
        drop_a++;
    for (drop_b = 0, j = F_NCMAX-1; 0 == h_rule[j] && j > 0; j--)
        drop_b++;
    nc = F_NCMAX - (drop_a + drop_b);

    fx->nc = nc;
    for (t = FMAP(fx), s = src + drop_a, i = F_NR;
         0 < i--;
         s += F_NCMAX, t+= F_NCMAX) {
             memcpy(t, s, nc);
         }
    }
return fx;
}

dfont(FONT *abc, char *lut)     /* print font */
{
FONT    fc;
int     nr, nc, ic, i, j;
BYTE   *t, *s;

for (ic = 0; ic < N_CHARS; ic++) {
    fc = abc[ic];
    nr = fc->nr;
    nc = fc->nc;
    t  = FMAP(fc);
    printf("[C%4.4d] %c nr=%d nc=%d \n", ic, ic+32, nr, nc);
    for (i= F_NR; 0 < i--; t+= F_NCMAX) {
        for (s = t, j = nc; 0 < j--; s++) {
            putchar(lut[*s]);
            }
        putchar('\n');
        }
    }
return OK;
}

sc_getc(int cprev, char **src, char *fin)
{
int     c;
char   *s = *src;
if  (s == fin) return EOF;
if  (cprev == ' ' && q_crunch) {
    c = *s++;
    if (c < ' ' || c > '~') c = ' ';
    while (c == ' ') {
        c = *s++;
        if (c < ' ' || c > '~') c = ' ';
        }
    }
else {
    c = *s++;
    if (c < ' ' || c > '~') c = ' ';
    }
*src = s;
return  c;
}

ss_scroll(FONT *abc, SCMD xc)
{
int     c = '.';
int     ncols = SR_NC;
int     j, key;
char    lut_c[LUT_SIZE];
char   *xp = xc->sc_perm;
char   *src = xc->sc_data.ADDR;
char   *eof = src + xc->sc_data.SDLEN;

memset(vs, 0, SR_SIZE);
for (;;) {
    key = DOS_ATTN;
    if (key == CTRLZ) system("");       /* DOS prompt */
    else if (key == CTRLB) q_crunch = 1 & ~q_crunch;
    else if (key == CTRLQ) return key;
    else if (key != 0) break;
    s_wait(n_wait);
    if (xc->sc_erode) rs_zap(xc->sc_erode, 1);
    rs_map(vs, xc->sc_lut, 1, xc->sc_flip);
    ncols = vs_sl(vs, ncols);
    if (ncols <= V_NC) {
        c = sc_getc(c, &src, eof);
        if (c == EOF) break;
        ncols = vs_catc(vs, ncols, abc[c-' ']);
        }
    else delay(1);
    if (xp != NULL) {   /* permute the lut */
        for (j = 0; j < LUT_SIZE; j++) lut_c[j] = xc->sc_lut[0X0F & xp[j]];
        memcpy(xc->sc_lut, lut_c, LUT_SIZE);
        }
    }
return OK;
}

ss_xscroll(FONT *abc, SCMD xc)
{
extern char   *malloc();
char   *s_lut;
int     c = ' ';
int     ncols = SR_NC;
int     key;
int     ix = 0;
int     maxi = strlen(xc->sc_cmap);
int     s_cnt  = 0;
int     j;
char   *xp = xc->sc_perm;
char   *src = xc->sc_data.ADDR;
char   *eof = src + xc->sc_data.SDLEN;
char    lut[LUT_SIZE];
char    lut_c[LUT_SIZE];

memset(vs, 0, SR_SIZE);

for (;;) {
    key = DOS_ATTN;
    if (key == CTRLZ) system("");       /* DOS prompt */
    else if (key == CTRLB) q_crunch = 1 & ~q_crunch;
    else if (key == CTRLQ) return key;
    else if (key != 0) break;
    s_wait(n_wait);
    if (s_cnt == 0) {    /* cycle through subset of lut_tab */
        s_lut = lut_tab[0X0F & xc->sc_cmap[ix++]];
        memcpy(lut, s_lut, LUT_SIZE);
        if (ix == maxi) ix = 0;
        s_cnt = xc->sc_cycle;
        }
    else s_cnt--;
    if (xc->sc_erode) rs_zap(xc->sc_erode, 1);
    rs_map(vs, lut, 1, xc->sc_flip);

    if (xp != NULL) {   /* permute the lut */
        for (j = 0; j < LUT_SIZE; j++) lut_c[j] = lut[0X0F & xp[j]];
        memcpy(lut, lut_c, LUT_SIZE);
        }

    ncols = vs_sl(vs, ncols);
    if (ncols <= V_NC) {
        c = sc_getc(c, &src, eof);
        if (c == EOF) break;
        ncols = vs_catc(vs, ncols, abc[c-' ']);
        }
    else delay(1);
    }
return OK;
}

vs_sl(BYTE *xx, int nc) /* shift left */
{
BYTE   *s, *t;
int     i, j;
nc--;
for (s = xx, i = F_NR; 0 < i--; s += SR_NC)
    for (t = s, j = nc; 0 < j--; t++)
        *t = *(t+1);
return nc;
}

vs_catc(BYTE *sr, int x, FONT fc)       /* add fc to shift register */
{
BYTE   *t;
BYTE   *s = FMAP(fc);
int     nc = fc->nc;
int     i;

for (t = sr + x, i = F_NR; 0 < i--; s += F_NCMAX, t += SR_NC) {
    *t = *(t+1) = 0;
    memcpy(t+2, s, nc);
    }
return x + 1 + nc;
}


    /* map shift register to screen */

rs_map(BYTE *src, BYTE* idx, int y, int qflip)
{
BYTE   *t = vram + y * 2 * V_NC;
BYTE   *s, *tz;
int     i, j;
if (qflip & FLIP_SCREEN) {
        for (i = F_NR; 0 < i--; src += SR_NC, t += 2*V_NC)
            for (j = V_NC, tz = t + 2*V_NC-2, s = src; 0 < j--; s++, tz -=2)
                *tz = idx[*s];
        return OK;
        }
for (i = F_NR; 0 < i--; src += SR_NC)
    for (j = V_NC, s = src; 0 < j--; s++, t+=2) /* skip attribute byte */
        *t = idx[*s];
return OK;
}

ww_puts(char *src, int y, int x, int nc)
{
BYTE   *t = vram + y * 2 * V_NC + (x*2);
int     maxj = strlen(src);
char   *s;
int     j;

for (s = src, j = 0; j < maxj && j < nc; j++, s++, t+=2) *t = *s;
for (; j < nc; j++, t+=2) *t = ' ';
return OK;
}

vdu_set_attr(int si)    /* colour */
{
BYTE   *t;
int     j;
for (t=vram+1, j = V_NR*V_NC; 0<j--; t+=2) *t = si;
return OK;
}

s_wait(unsigned long cnt)        /* short wait */
{
while(cnt > 0) cnt--;
return cnt;
}

rs_zap(int np, int y) /* blank part of screen */
{
BYTE   *t = vram + y * 2 * V_NC;
BYTE   *s;
while (0 < np--) {
    s = t + 2 * IRAND(F_NR*V_NC);
    *s = ' ';
    }
return OK;
}

int get_video_mode()
{
union   REGS xx;
xx.h.ah = 0X0F;         /* set video mode */
xx.h.al = 0;
xx.x.bx = xx.x.cx = 0;
int86(0X10, &xx, &xx);
return (0X7F & xx.h.al);
}

reverse_memcpy(t, s, nc)        /* mirror movement option */
BYTE   *t;      /* destination */
BYTE   *s;      /* source */
int     nc;     /* count */
{
for (s += nc-1; 0 < nc--; *t++ = *s--);
return OK;
}

sc_zload(dst, file)     /* read file into object */
SLICE   dst;            /* file image --raw data */
BYTE   *file;           /* file name */
{
extern  char *malloc();
extern  long lseek();
int     rc;     /* return code */
long    nsize;  /* file size */
unsigned int  n;
int     fd;     /* result of open */

if (file == NULL ||
    ERROR == (fd = open(file, O_RDONLY))) return ERROR;

nsize = lseek(fd, 0L, SEEK_END);
n     = nsize;
dst->ADDR = malloc(n);
if (dst->ADDR) {
    lseek(fd, 0L, SEEK_SET);
    dst->SDLEN = read(fd, dst->ADDR, n);
    }
close(fd);
return (dst->ADDR) ? OK : ERROR;
}



