    /*      select n numbers from {1,2,...m}  based on time() */

    #include <stdio.h>
    #include <math.h>
    #include <time.h>

    #define MAX_BALLS       1000

    /* hold numbered balls in an urn or jar */

    int     urn[MAX_BALLS];

    main(argc, argv)
    int argc;
    char **argv;
    {
    int     n, m;
    int     i, k;

    if (argc < 3) {
        printf ("Usage %s number-to-select number-of-lottery-balls \n");
        return -1;
        }

    n = atoi(*++argv);
    m = atoi(*++argv);

    /* sanity check */
    if (n > MAX_BALLS || m > MAX_BALLS || n > m || n < 0 || m < 0) {
    /* brush off user with a cryptic error message */
        printf("arguement error. Don't bet today\n");
        return -1;
        }
    printf ("Selecting %d balls from %d without replacement\n", n, m);

    /* deterministic randomize */
    srand((unsigned)time(NULL));

    for (i=0; i<m; i++) urn[i]=0;
    for (i=0; i<n; i++) {           /* select n balls */
         for (k = rand() % m; urn[k]; k = rand() % m);
         urn[k]=1;
         }
    for (i = 0; i < m; i++) {
        if (urn[i]) printf("%d ", 1+i);
        }
    printf("\n");
    return  0;
    }







