/* test d4_stat */

#include <dos.h>
#include <io.h>
#ifdef TC
#include <dir.h>
#define _A_HIDDEN FA_HIDDEN
#define _A_SYSTEM FA_SYSTEM
#define _A_RDONLY FA_RDONLY
#define _A_SUBDIR FA_DIREC
#endif

main(argc, argv)
int argc;
char ** argv;
{
int     d4_stat();
int     x;
if (argc <2 )return 255;

printf("_A_HIDDEN %2.2X\n", _A_HIDDEN);
printf("_A_SYSTEM %2.2X\n", _A_SYSTEM);
printf("_A_RDONLY %2.2X\n", _A_RDONLY);
printf("_A_SUBDIR %2.2X\n", _A_SUBDIR);


x = d4_stat(*++argv);  /* first arguement */
printf("fstat = %4.4X %6.6o %d\n", x, x, x);
return 0;
}

#ifdef  USE_UNIX_STAT

#include <sys/stat.h>

int     d4_stat(name)   /* give file status as ordinary int */
char   *name;
{
struct  stat    file_mode;
int     rc = stat(name, &file_mode);
return (rc) ? 0: (int) file_mode.st_mode;
}

#else

/*
Syntax
------

     #include <io.h>

     int _chmod(const char *filename, int func, mode_t mode);

Description
-----------

This is a direct connection to the MS-DOS chmod function call, int
0x21, %ax = 0x4300/0x4301.  If FUNC is 0, then DOS is called with AX =
0x4300, which returns an attribute byte of a file.  If FUNC is 1, then
the attributes of a file are set as specified in MODE.  Note that the
directory and volume attribute bits must always be 0 when `_chmod()' is
called with FUNC = 1, or else the call will fail.  The third argument
is optional when getting attributes.  The attribute bits are defined as
follows:

       Bit       Meaning
     76543210
     .......1    Read-only
     ......1.    Hidden
     .....1..    System
     ....1...    Volume Label
     ...1....    Directory
     ..1.....    Archive
     xx......    Reserved (used by some network redirectors)

Return Value
------------

If the file exists, `_chmod()' returns its attribute byte in case it
succeded, or -1 in case of failure.

*/
#include <ctype.h>
#include <dos.h>
#include <io.h>

#define UNIX_RDONLY     0444
#define UNIX_X          0111
#define UNIX_WRITE      0222

int     d4_stat(name)   /* give file status as ordinary int */
char   *name;
{
extern  int     strcmp();
char    ext[4];
int     n = strlen(name);
int     rc = _chmod(name, 0);
int     j, isdir, perm;
char   *s = name + n-4;

printf("_chmod %s ->%4.4X %d\n", name, rc, rc);

if (rc < 0) return 0;   /* no file */
else if (rc == 0) return 0777;
isdir = (rc & _A_SUBDIR ) ? 030000 : 0;        /* octal constants */
perm  = (rc & (_A_RDONLY | _A_SYSTEM))  ? UNIX_RDONLY
                                        : (UNIX_RDONLY | UNIX_WRITE);
if (isdir && 0 == (rc & _A_HIDDEN))
    perm |= UNIX_X;              /* search permission for directory */
else if ( n > 4 || *s == '.') {
    for (s++, j=0; j < 3; s++) ext[j++] = tolower(*s);
    ext[3] = 0;
    if (strcmp(ext, "com")
        || strcmp(ext, "exe")
        || strcmp(ext, "pif")
        || strcmp(ext, "bat"))
        perm |= UNIX_X;
    }
return (isdir | perm);
}

#endif
