/* draw an x on the video screen */

#include <dos.h>

#define OK      0
#define TRUE    1
#define IRAND(X)        (rand()%(X))
#define BREAK   0X03    /* CTRL-C */
#define K_CLS   0X0C    /* CTRL-L */
#define CTRLZ   0X1A    /* CTRL-Z */

/*      Unsolicited keyboard input */
#define DOS_ATTN        (0X00FF & bdos(0X06,0XFF, 0))
#define BRAKE   BREAK == DOS_ATTN /* STOP ! */

long int     long_time = 130000L;
int     s_attr = -1;
int     s_nr = 24;
int     s_nc = 80;
int     n_wait = 0;
int     x_t = 312;      /* threshold */
int     xxi[3000];

main(argc, argv)
int     argc;
char  **argv;
{
extern  long atol();
char   *s;
int    *ix;
int     d1, d2, i, j, k;
int     gchar = 'O';
int     rc, key;
char   *lut = " ......+#OOO@@@@@@RedundantTechnology";

/* parse arguements */

for (argv++; 0<argc--; argv++)
    switch(*(s = *argv)) {
        case 'A':       /* attribute, or colour of screen */
        case 'a':  s_attr = atoi(s+2);
            break;
        case 'D':       /* delay */
        case 'd':  n_wait = atoi(s+2);
            break;
        case 'N':       /* long_time */
        case 'n':  long_time = atol(s+2);
            break;
        case 'T':       /* threshold */
        case 't':  x_t = atoi(s+2);
            break;
        case 'X':       /* start character .. decimal to ascii */
        case 'x':  gchar = atoi(s+2);
            break;
        case 'L':       /* lut = look-up table */
        case 'l':  lut = s+2;
            break;
        case 'H':       /* help */
        case 'h':       /* usage message */
        case '?':  return usage();
        default:
            break;
        }

    /* create map (X-cross) */

for (ix = &xxi[0], i = 0; i < s_nr; i++)
    for (j = 0; j < s_nc; ix++, j++) {
        k = i*s_nc - j*s_nr;
        if (k < 0) k = -k;
        d1 = k;
        k = i*s_nc - (s_nc-j)*s_nr;
        if (k < 0) k = -k;
        d2 = k;
        k = (d1<d2) ? d1 : d2;
        ix[0] = k < x_t;
        }

        /* colour of screen */
if (s_attr != -1) vdu_set_attr(s_attr);

print_scr(xxi, gchar);

if (0 == strlen(lut))
    return print_str("Zero length L(lut) parameter");

for (rc = 0; rc == 0;) {
    key = DOS_ATTN;
    if (key == BREAK || key == CTRLZ) rc = key;
    else rc = lut_cycle(xxi, lut, long_time) |
              print_scr(xxi, ' ');    /* refresh */
    if (rc == K_CLS) rc = 0;
    }
return rc;
}

print_scr(int *si, int gc)
{
int     i, j;
for (i = 0; i < s_nr; i++) {
    tcur(0, i);
    for (j = 0; j < s_nc; si++, j++) vputch((si[0]) ? gc : ' ');
    }
return 0;
}

   /* print a character from lut at si>0 */

lut_cycle(int *si, char *lut, long int iter_max)
{
long    int     cnt = iter_max;
int     nsize = s_nr * s_nc;
int     nlut  = strlen(lut);
int     z, key;
int     rc = 0;

while (rc == 0) {
    if (iter_max != 0L && 0 == cnt--) rc = K_CLS;
    key = DOS_ATTN;
    if (key == BREAK || key == CTRLZ) rc = key;
    z = IRAND(nsize);
    if (si[z]) {
        tcur(z % s_nc, z/s_nc);
        vputch(lut[IRAND(nlut)]);
        delay(n_wait);
        }
    }
return rc;
}

/*  Console I/O
*   MS-DOS console IO
*/

/* ansi calls replaced by dos to make it work with > 25 rows */

vputch (c)
int     c;
{
union   REGS xx;
xx.h.ah = 0X0E;         /* output char in teletype mode */
xx.h.al = c;            /* this character */
xx.x.bx = xx.x.cx = 0;
int86(0X10, &xx, &xx);
return OK;
}

tcur(X,Y)       /* LOCATE X,Y   Text Cursor<-X,Y */
int     X,Y;
{
union   REGS xx;
xx.h.ah = 0X02;         /* set cursor position */
xx.h.al = 0;
xx.x.bx = xx.x.cx = 0;
xx.h.dh = Y;            /* row    Y */
xx.h.dl = X;            /* column X */
int86(0X10, &xx, &xx);
return OK;
}

print_str(char *s)
{
while (*s) vputch(*s++);
vputch(0X0A);
vputch(0X0D);
return OK;
}

usage()
{
print_str("Usage: x d=delay x=start_char l=lut t=thickness n=long_time");
print_str("d=delay [0-32000]");
print_str("x=start_char [32-255]");
print_str("t=thickness integer [0-350]");
print_str("l=lut [printable characters]");
print_str("n=long_time [1-32000000] 0=never");
print_str("a=screen attributes [0-255] 1-15=basic colours");
return OK;
}

/*
*     B800:0000 text ram screen mode 7.
*     B000:0000 mono adaptor / mode 3
*/


vdu_set_attr(int si)
{
unsigned char*  vram = (unsigned char*) 0XB8000000L;
unsigned char*  t;
int     j;
for (t=vram+1, j= s_nr*s_nc; 0<j--; t+=2) *t = si;
return OK;
}
