/*      FXKER.C -- Memory | port | channel routines */

#include <ctype.h>
#include <na.h>
#include <fdata.h>
#include <dos.h>
#include <io.h>

#ifdef TC

#include <dir.h>
#define I2_MAX  ((int) 0X7FFF)
#define I2_MIN  ((int) 0X8001)
#define _A_HIDDEN FA_HIDDEN
#define _A_SYSTEM FA_SYSTEM
#define _A_RDONLY FA_RDONLY
#define _A_SUBDIR FA_DIREC
#define FINDFIRST(P,A,FCB)  findfirst(P, FCB, A)
#define FINDNEXT(FCB)       findnext(FCB)
#define find_t ffblk
#define name ff_name
#define attrib ff_attrib
#define GETDATE(X) getdate(X)
#define GETTIME(X) gettime(X)
#define dosdate_t  date
#define dostime_t  time
#define year da_year
#define day da_day
#define month da_mon
#define hour ti_hour
#define minute ti_min
#define second ti_sec
#else


#define I2_MAX  ((int) 0X7FFFFFFF)
#define I2_MIN  ((int) 0X80000001)

#define FINDFIRST(P,A,FCB)  _dos_findfirst(P,A,FCB)
#define FINDNEXT(FCB)       _dos_findnext(FCB)
#define GETDATE(X)          _dos_getdate(X)
#define GETTIME(X)          _dos_gettime(X)

#endif

/* _A_NORMAL       0x00       Normal file - No read/write restrictions */
/* _A_RDONLY       0x01       Read only file */
/* _A_HIDDEN       0x02       Hidden file */
/* _A_SYSTEM       0x04       System file */
/* _A_VOLID        0x08       Volume ID file */
/* _A_SUBDIR       0x10       Subdirectory */
/* _A_ARCH         0x20       Archive file */


/* DIRECTORY SEARCH */

/* test whether to find all files
*  this is indicated by a file name component which is empty or a single
*  star (*).  #files "path/" or #files "path/*" will return the entire
*  directory. This routine is troublesome because 100% compatability
*  with UNIX is desirable.
*/

fx_dtxt(dst, lo, fp)    /*  {attributes} #files "*.*" */
MATRIX  dst;            /* list */
MATRIX  lo;             /* attributes */
char   *fp;             /* ASCIZ file name */
{
extern  char   *malloc();
extern  SLIST sl_push();
SLIST   t;
struct  find_t *fda;
struct  SDESC tt;
int     attrib = (_A_RDONLY | _A_SYSTEM | _A_HIDDEN);       /* default */
int     c, k, n, rc, qfind, q_all, q_scan;
char   *fn, *fpx, *s;

if (fp == NULL || 0 == (n = strlen(fp))) return mkobj(dst, 'T', 0, 0);
k = (lo != NULL) ? (17 & *(INT_PTR(lo))): 1;

if (k & 16 ) attrib  |= _A_SUBDIR;

for (q_scan = q_all = 0, s = fn = fp; *s; s++) {
    c = *s;
    if (c == '/' || c == '\\') fn = s+1;
    else if (c == '?' || c == '*') q_scan = 1;
    }

if (q_scan == 0 && n > 0) {     /* just test for existance */
    rc = d4_stat(fp);
    return (rc) ? mk_zstr(dst, fp) : mkobj(dst, 'T', 0, 0);
    }
n = strlen(fn);
if (n == 0) q_all = 1;
else if (n == 1 && (*fn == '*' || *fn == '.')) {
    q_all = 1;
    *fn = 0;
    }

if (q_all) {
    fpx = malloc(5 + strlen(fp));
    sprintf(fpx, "%s*.*", fp);    /* match *.*  */
    }
else    fpx = fp;

if (mk_tabs(dst,     1, sizeof(struct find_t)) ||
      mkobj(dst+1, 'L', 1, 1))          /* linked list */
    return ERROR;

fda = (struct find_t *) TEXT_PTR(dst);
tt.ADDR = fda->name;

for   (t = (SLIST)LINK_PTR(dst+1), rc = FINDFIRST(fpx, attrib, fda);
       rc == OK;
       rc = FINDNEXT(fda)) {
     qfind =  (k == 16) ? fda->attrib & _A_SUBDIR : 1;
     if (qfind) {
        tt.SDLEN = strlen(fda->name);
        t = sl_push(t, &tt);
        }
    }

if (q_all) free (fpx);

rc = sl_cat('M', dst, S_NEXT(LINK_PTR(dst+1)), NULL) ||
     sys_del(dst+1);
return rc;
}

#ifdef TC

fx_peek(dst, lo, hi)      /* peek , poke */
MATRIX dst;
MATRIX lo;
MATRIX hi;
{
BYTE *s, *t;
int *ix = INT_PTR(hi);
int qpoke = (lo != NULL);
int i, n, nr, nc;
n = rho(hi, &nr, &nc);
if (n == 0) return (OK);
else if (nc != 2) return (ERROR);
if (qpoke)      t = lo->ADDR + HDSIZE;
else if (mkobj(dst, 'T', nr, nr)) return ERROR;
else t = dst->ADDR+HDSIZE;

for (i=0; i<nr; i++, ix += nc) {
        FP_SEG(s) = ix[0];
        FP_OFF(s) = ix[1];
        if (qpoke) *s = *t++;
        else       *t++ = *s;
        }
if (qpoke) mkobj(dst, 'T', 0, 0);
return (OK);
}

#else

fx_peek(dst, lo, hi)        /* peek, poke */
MATRIX  dst;
MATRIX  lo;
MATRIX  hi;
{
int     n = MSIZE(hi->ADDR);
BYTE  **s, *t;
int     m, dx = 1;

if (lo == NULL) {
    if (mkobj(dst, 'T', n, n)) return ERROR;
    for (t = TEXT_PTR(dst), s = (BYTE**)(INT_PTR(hi));
         0 < n--;
        *t++ = *(*s++));
    return OK;
    }

m = MSIZE(lo->ADDR);    /* poke */

if (m == 1) dx = 0;
else if (m != n) return ERROR;
for (t = TEXT_PTR(lo), s = (BYTE**)(INT_PTR(hi)); 0 < n--; *(*s++) = *t)
        t += dx;
return OK;
}

#endif

fx_port(dst, lo, hi)    /* write to channel */
MATRIX dst;
MATRIX lo;              /* data */
MATRIX hi;              /* number */
{
return ERROR;
}

fx_inp(dst, hi)         /* read com port */
MATRIX dst;
MATRIX hi;
{
return ERROR;
}

fx_lprint(dst, src)     /* send text (bytes) to printer */
MATRIX dst;             /* number of characters printed */
MATRIX src;             /* any character vector */
{
BYTE   *s  = src->ADDR;
int     n  = MSIZE(s);
int     j, c;
if (MTYPE(s) != TYPT) return ERROR;
for (s = TEXT_PTR(src), j = n; 0 < j--; s++)
    bdos(0X05, *s, 0);
return mkik(dst, n);
}

/*      dangerous code
*       DOS/WINDOWS software interrupt to allow hacking.
*       .. or ratting to deal with the mouse.
*       The turbo-C version assumes the register in an ordered list
*       ax, bx, cx, dx, si, di, cflag, flags
*       DJGPP uses an entirely different order, with #ifdef options.
*       This means registers can no longer be block copied.
*
*/

#ifdef  DJGPP

fx_86(dst, lo, hi)
MATRIX dst, lo, hi;
/*      AX,BX,CX,DX <- (AX,BX,CX,DX) #int N    */
{
union   REGS    rx;
int     n   = MSIZE(lo->ADDR);
int     num = * (INT_PTR(hi));  /* the interrupt */
int    *ix = INT_PTR(lo);
if (n > 4) n = 4;
rx.x.ax = 0;
rx.x.bx = 0;
rx.x.cx = 0;
rx.x.dx = 0;
if (n > 0) rx.w.ax = (unsigned short) (*ix++);
if (n > 1) rx.w.bx = (unsigned short) (*ix++);
if (n > 2) rx.w.cx = (unsigned short) (*ix++);
if (n > 3) rx.w.dx = (unsigned short) (*ix++);
int86(num, &rx, &rx);
if (OK == mkobj(dst, 'N', 4, 4)) {
    ix = INT_PTR(dst);
    *ix++ = (int) rx.w.ax;
    *ix++ = (int) rx.w.bx;
    *ix++ = (int) rx.w.cx;
    *ix++ = (int) rx.w.dx;
    return OK;
    }
else return ERROR;
}

#else   /* TC */

fx_86(dst, lo, hi)
MATRIX dst, lo, hi;
/*      AX,BX,CX,DX <- (AX,BX,CX,DX) #int N    */
{
union   REGS    rx;
unsigned int   *iy = (unsigned int*) &rx;
int     n   = MSIZE(lo->ADDR);
int     num = * (INT_PTR(hi));  /* the interrupt */
if (n > 4) n = 4;
memset(&rx, 0, 8);              /* clear */
memcpy(&rx, lo->ADDR+HDSIZE, n * sizeof(int));
int86(num, &rx, &rx);
if (OK == mkobj(dst, 'N', 4, 4)) {
    memcpy(INT_PTR(dst), &rx, 4*sizeof(int));
    return OK;
    }
else return ERROR;
}

#endif

        /* ENQUIRE DATE AND TIME */

fx_ts(dst)      /* time stamp */
MATRIX  dst;    /* Year Month Day Hour Minute Second */
{
struct  dosdate_t  ts_date;
struct  dostime_t  ts_time;
int    *ix;
  if (mkobj(dst, 'N', 6, 6)) return ERROR;
  else    ix = INT_PTR(dst);
  GETDATE(&ts_date);
  GETTIME(&ts_time);
  ix[0] = ts_date.year;
  ix[1] = ts_date.month;
  ix[2] = ts_date.day;
  ix[3] = ts_time.hour;
  ix[4] = ts_time.minute;
  ix[5] = ts_time.second;
return OK;
}

mk_nltab(dst, src)      /* make list of names as matrix */
MATRIX  dst;    /* matrix of names */
MATRIX  src;    /* a name list */
{
BYTE   *s  = src->ADDR;
int     n  = MSIZE(s);
int     nc = MCOLS(s);
struct  SDESC   ss;

if (TYPT != MTYPE(s)) return ERROR;
if (n != nc) return OK;        /* do nothing */
else if (fx_deb(dst, src)) return ERROR;
    ss.ADDR  = TEXT_PTR(dst);
    ss.SDLEN = MSIZE(dst->ADDR);
return ss_mat(src, &ss, ' ') || sasr(dst);
}

fx_symop(fc, dst, src)  /* symbol operations */
int     fc;     /* function:  nc = class, ex = delete, varptr = pointer */
MATRIX  dst;    /* return vector */
MATRIX  src;    /* a name list */
{
extern  MATRIX  pm_sym;
extern  MATRIX  sys_vget();
BYTE   *s, *t;
int     n, nc, nr, k, rc;
int    *di;
MATRIX  p;
struct  SDESC   tt;

if (mk_nltab(dst, src)) return ERROR;   /* convert src to matrix */

s  = src->ADDR;
n  = MSIZE(s);
nc = MCOLS(s);
if (nc == 0) return ERROR;
nr = n / nc;

if (fc == F_NC || fc == F_EX)
    rc = mkobj(dst, 'N', nr, nr);
else if (fc == F_VARPTR)
#ifdef  TC
    rc = mkobj(dst, 'N', 2 * nr, 2);
#else
    rc = mkobj(dst, 'N',  nr, 1);
#endif
else    return ERROR;

for (di = INT_PTR(dst), s = TEXT_PTR(src); rc == 0 && 0 < nr --; s += nc) {
    tt.ADDR = s;
    for (t = s+nc-1; t>s && *t == ' '; t--);
    tt.SDLEN = (t-s)+1;
    p  =  sys_vget(pm_sym, &tt);
    switch(fc) {
        case F_NC:      /* name class */
            *di++ = (p == NULL || p->ADDR == NULL) ? 0 : MTYPE(p->ADDR);
        break;
        case F_EX:      /* delete */
            if (p == NULL || p->ADDR == NULL) k = 0;
            else {
                rc |= sys_del(p);       /* function is complicated */
                k = 1;
                }
            *di++ = k;
        break;
        case F_VARPTR:  /* data pointer */
            if (p == NULL) t = (BYTE*) p;
            else           t = p->ADDR;
#ifdef  TC
            *di++ = FP_SEG(t);
            *di++ = FP_OFF(t);
#else
            *di++ =(int) t;
#endif
        break;
        default: break;
        }
    }
return rc;
}

fx_cvt(dst, op, src)    /* general data conversion */
MATRIX  dst;
MATRIX  op;
MATRIX  src;
{
BYTE   *s  = src->ADDR;
int     dx = MTYPE(s);
BYTE   *t  = op->ADDR;
int     fc;

if (t == NULL || 0 == MSIZE(t)) return ERROR;

if (MTYPE(t) == TYPN)           fc = *(INT_PTR(op));
else if (MTYPE(t) == TYPT)      fc = (int) *(TEXT_PTR(op));
else    return ERROR;

switch (fc) {
    case 'T':
    case TYPT:  /* text */
        if (dx == TYPT)         return sasa(dst, src);
        else if (dx == TYPN)    return fx_av(dst, src);
        break;
    case 'N':
    case TYPN:  /* integer */
        if (dx == TYPN)         return sasa(dst, src);
        else if (dx == TYPT)    return fx_av(dst, src);
        else if (dx == TYPD)    return fx_cvi(dst, src);
        break;
    case 'D':
    case TYPD:  /* float */
        if (dx == TYPD)         return sasa(dst, src);
        else if (dx == TYPN)    return fx_cvd(dst, src);
        break;
    default: break;
    }
return ERROR;
}

fx_av(dst, src)         /* char <=> ASCII conversion */
MATRIX  dst;
MATRIX  src;
{
BYTE   *s = src->ADDR;
int     dx = MTYPE(s);
int     n  = MSIZE(s);
int     nc = MCOLS(s);
int    *si;

if (n == 0)       return sasa(dst, src);
else if (nc == 0) return ERROR;
if (dx == TYPN) {       /* numeric to character */
    if (mkobj(dst, 'T', n, nc)) return ERROR;
    for(s = TEXT_PTR(dst), si = INT_PTR(src); 0 < n--;  s++, si++)
        *s = (BYTE)(*si);
    }
else if (dx == TYPT) {  /*      ASCII values of text */
    if (mkobj(dst, 'N', n, nc)) return ERROR;
    for(si = INT_PTR(dst), s = TEXT_PTR(src); 0 < n--; s++, si++)
        *si = (int) *s;
    }
else return ERROR;
return OK;
}

fx_cvd(dst, src)        /* convert to double */
MATRIX  dst;
MATRIX  src;            /* must be numeric */
{
BYTE   *s  = src->ADDR;
int     n  =  MSIZE(s);
int     nc =  MCOLS(s);
int    *ix;
DOUBLE *x;

if (MTYPE(s) == TYPD) return sasa(dst, src);
else if (MTYPE(s) == TYPN) {
    if (mkobj(dst, 'D', n, nc)) return ERROR;
    for (x = DBL_PTR(dst), ix = INT_PTR(src); 0 < n--;)
        *x++ = (DOUBLE) (*ix++);
    return OK;
    }
else return ERROR;
}

fx_cvi(dst, src)        /* double to integer */
MATRIX  dst;
MATRIX  src;            /* must be numeric */
{
BYTE   *s  = src->ADDR;
int     n  =  MSIZE(s);
int     nc =  MCOLS(s);
int    *di;
DOUBLE *x, xr;

if (MTYPE(s) == TYPN) return sasa(dst, src);
else if (MTYPE(s) == TYPD) {
    if (mkobj(dst, 'N', n, nc)) return ERROR;
    for (x = DBL_PTR(src), di = INT_PTR(dst); 0 < n--; di++, x++) {
        xr = *x;
        if (xr > (DOUBLE) I2_MAX)      xr = (DOUBLE) I2_MAX;
        else if (xr < (DOUBLE) I2_MIN) xr = (DOUBLE) I2_MIN;
        *di = (int) xr;
        }
    return OK;
    }
else return ERROR;
}

fx_call(dst, lo, hi)
MATRIX  dst;    /* result */
MATRIX  lo;     /* paramaters to be used as AX,BX,CX,DX,SI,DI etc */
MATRIX  hi;     /* code */
{
BYTE   *s = hi->ADDR;
int    *ax;
int (*code)();

#ifdef  DJGPP
return sasa(dst, lo);
#else

if (MTYPE(s) != TYPT) return ERROR;
else if (MSIZE(s) != 0 &&
         MTYPE(lo->ADDR) == TYPN &&
         MSIZE(lo->ADDR) > 0) {
    code = (int(*)()) TEXT_PTR(hi);
    ax   = INT_PTR(lo);
    code(ax[0], ax[1], ax[2], ax[3], ax[4], ax[5]);
    }
return sasa(dst, lo);

#endif
}

/* rather dangerous routines to test */

#define DSK_SET     0
#define DSK_STATUS  1
#define DSK_READ    2
#define DSK_WRITE   3

fx_disk(MATRIX dst, MATRIX data, MATRIX fcvec)       /* bios disk */
{
extern  int biosdisk();
int     fc;     /* AH on INT13 call */
int     size, rc;
BYTE   *s = fcvec->ADDR;
int    *ix;

if (fcvec == NULL) return ERROR;
s  = fcvec->ADDR;
if (s == NULL || MTYPE(s) != TYPN || MSIZE(s) < 1) return ERROR;
ix = INT_PTR(fcvec);
fc = ix[0];
switch (fc) {
    case DSK_SET:       /* set */
    case DSK_STATUS:    /* status */
        rc = biosdisk(fc, ix[1], 0, 0, 0, 0, NULL);
        return mkik(dst, rc);
        break;
   case DSK_READ:       /* read nsecs @ drive head track sector */
       if (MSIZE(s) < 6) return ERROR;
       size = 512 * ix[5];
       if (mkobj(dst, 'T', size, size)) return ERROR;
       rc = biosdisk(fc, ix[1], ix[2], ix[3], ix[4], ix[5], TEXT_PTR(dst));
       return OK;
       break;
   case DSK_WRITE:      /* write nsecs @ drive head track sector */
       if (data == NULL || MSIZE(s) < 6) return ERROR;
       size = 512 * ix[5];
       s = data->ADDR;
       if (MTYPE(s) != TYPT || MSIZE(s) != 512 * ix[5]) return ERROR;
       rc = biosdisk(fc, ix[1], ix[2], ix[3], ix[4], ix[5], TEXT_PTR(data));
       return mkik(dst, rc);
    default:
       break;
       }
return ERROR;
}

fx_cwd(dst)
MATRIX dst;
{
extern  char *getcwd();
struct  SDESC tt;
mkobj(dst+1, 'T', 65, 65);
tt.ADDR = TEXT_PTR(dst+1);
tt.SDLEN = 64;
if (NULL != getcwd(tt.ADDR, 64)) tt.SDLEN = strlen(tt.ADDR);
else  tt.SDLEN = 0;
return mk_sk(dst, TYPT, &tt) || sasr(dst+1);
}

mk_zstr(p, s)   /* Object from string */
MATRIX  p;
BYTE   *s;
{
int     n = strlen(s);
if (mkobj(p, 'T', n, n)) return ERROR;
memcpy(TEXT_PTR(p), s, n);
return OK;
}

/*
Syntax
------


     int _chmod(const char *filename, int func, mode_t mode);

Description
-----------

This is a direct connection to the MS-DOS chmod function call, int
0x21, %ax = 0x4300/0x4301.  If FUNC is 0, then DOS is called with AX =
0x4300, which returns an attribute byte of a file.  If FUNC is 1, then
the attributes of a file are set as specified in MODE.  Note that the
directory and volume attribute bits must always be 0 when `_chmod()' is
called with FUNC = 1, or else the call will fail.  The third argument
is optional when getting attributes.  The attribute bits are defined as
follows:

       Bit       Meaning
     76543210
     .......1    Read-only
     ......1.    Hidden
     .....1..    System
     ....1...    Volume Label
     ...1....    Directory
     ..1.....    Archive
     xx......    Reserved (used by some network redirectors)

Return Value
------------

If the file exists, `_chmod()' returns its attribute byte in case it
succeded, or -1 in case of failure.

    Translate these values for linux.
    WARNING !!!  these values may be different for UNIX

*/

#define LINUX_IFDIR  0040000
#define UNIX_RDONLY     0444
#define UNIX_X          0111
#define UNIX_WRITE      0222

int     d4_stat(name)   /* give file status as ordinary int */
char   *name;
{
extern  int     strcmp();
char    ext[4];
int     n = strlen(name);
int     j, isdir, perm;
int     rc;
char   *s = name + n-4;

if (n == 0 || (rc = _chmod(name, 0)) < 0) return 0;     /* no file */
else if (rc == 0) return 0777;
isdir = (rc & _A_SUBDIR ) ? LINUX_IFDIR : 0;    /* cf S_IFDIR */
perm  = (rc & (_A_RDONLY | _A_SYSTEM))  ? UNIX_RDONLY
                                        : (UNIX_RDONLY | UNIX_WRITE);
if (isdir && 0 == (rc & _A_HIDDEN))
    perm |= UNIX_X;              /* search permission for directory */
else if ( n > 4 || *s == '.') {
    for (s++, j=0; j < 3; s++) ext[j++] = tolower(*s);
    ext[3] = 0;
    if (strcmp(ext, "com")
        || strcmp(ext, "exe")
        || strcmp(ext, "pif")
        || strcmp(ext, "bat"))
        perm |= UNIX_X;
    }
return (isdir | perm);
}

/* sleep, usleep */

int     fx_sleep(dst, delay) /* #sleep seconds, microseconds */
MATRIX  delay;
MATRIX  dst;
{
#ifndef TC
extern  int     sleep();
extern  int     usleep();
#endif
int     n = MSIZE(delay->ADDR);
int    *ix = INT_PTR(delay);
int     rc = 0;
if (n==0 || TYPN != MTYPE(delay->ADDR)) return mkik(dst, ERROR);
if (ix[0]) sleep ((unsigned) rc = ix[0]);
#ifndef TC
if (n>1 && ix[1]) usleep((unsigned) rc=ix[1]);
#endif
return mkik(dst, rc);
}

/* #socket functions return the same sort of stuff  */

fx_socket(dst, lo, hi)  /* socket functions */
MATRIX  dst;            /* result */
MATRIX  lo;             /* host */
MATRIX  hi;             /* number, mode */
{
return mkik(dst, ERROR);
}

sockstat(dst)   /* return socket table */
{
return mkik(dst, ERROR);
}

read_socket(dst, hi)
MATRIX dst;     /* result */
MATRIX hi;      /* socket number */
{
return ERROR;
}

/*      $SOCKET[num, addr1, addr2, addr3, addr4]<-DATA */

write_socket(dst, data, hi)
MATRIX dst;     /* result */
MATRIX data;    /* data */
MATRIX hi;      /* socket number + destination */
{
return mkik(dst, 0);
}


