/*   KB.C   Console I/O */

#include <dos.h>
#include <htext.h>
#include <na.h>

#define KB_EOF  (-1)

/* use macros to acces bit significant code
        I_XLATE        translate
        I_FLIP         reverse
        I_PUSH         push mode
        I_NUM          reverse
        Q_BIT()
        BIT_INV()

*/

unsigned int a_astate = 0;      /* language code bits for arabic etc. */
unsigned int s_imode =  0;      /* insert | overlay */
unsigned int s_mouse =  0;      /* delay after mouse hit */
#define M_SLEEP 250000

#define CFK1    0X3B            /* semicolon ';' for 00+PFK1 */

char pfk[] =
{PFK1, PFK2, PFK3, PFK4, PFK5, PFK6, PFK7, PFK8, PFK9, PF10};

int vget_pushed = KB_EOF;

BYTE   *kb_ttx = NULL;

vgetch()           /* use bdos. IBM specific */
{                  /* xlate function keys to control codes */
extern  int     usleep();
extern  int     xterm_mouse();
extern  int     kbhit();
extern  MATRIX  sys_text();
extern  MATRIX  pm_sym;
MATRIX  kbmap = sys_text(pm_sym, "$KB");        /* keyboard mapping */
unsigned ax;
int k, cnt;

/* deal with keyboard mapping */
if (kbmap == NULL ||
    TYPT   != MTYPE(kbmap->ADDR) ||
    256    != MSIZE(kbmap->ADDR))
        kb_ttx = NULL;
else    kb_ttx = TEXT_PTR(kbmap);

/*      for vkpush()  july 1987  */
if (KB_EOF != vget_pushed) {
    ax = vget_pushed;
    vget_pushed = KB_EOF;
    return (kb_ttx) ? kb_ttx[ax] : ax;
    }

#ifdef DJGPP
/*      poll mouse  */

if (sys_text(pm_sym, "$MOUSE")) {
    while (! kbhit()) {
        ax = xterm_mouse();
        if (ax) {
            usleep(M_SLEEP);
            return ax;
            }
        }
    }
#endif

/*      get key and translate */

if (ax = DOSKEY) {
    if (a_astate & I_XLATE) ax |= 0X80;
    return (kb_ttx) ? kb_ttx[ax] : ax;
    }

/*      interpret numeric pad. 10 KEYS */
switch (ax = DOSKEY) {
    case 'K' : return KLEFT;
    case 'H' : return KUP;
    case 'M' : return KRGHT;
    case 'P' : return KDOWN;
    case 'S' : return DEL;
    case 'R' : return CTRLV;
    case 'Q' : return CTRLJ;
    case 'I' : return CTRLU;
    case 'G' : return CTRLK;
    case 'O' : return CTRLZ;
    default  : k = ax - CFK1;
    }

    if (k >= 0 && k < 10) ax = pfk[k];

return (kb_ttx) ? kb_ttx[ax] : ax;
}

vkpush(c)       /* push character */
int     c;
{
vget_pushed = c;
return OK;
}

inkey()         /* translate horizontal movement keys */
{
int  c;
int done;
int tmp;
for (done = 0; done == 0;) {
        switch(c = vgetch()) {
        default: done = 1;
                break;
        case CLEFT:     /* Arabic => forwards */
        case CRGHT:     /* Arabic => backwards */
                c = ((0 != (a_astate & I_FLIP))^(c == CLEFT))
                ? CLEFT : CRGHT;
                done = 1;
                break;
        case CTRLA:     /* toggle xlate and push mode */
                BIT_XOR(a_astate, tmp, I_PUSH|I_XLATE);
                break;
        case CTRLV:     /* toggle insert mode */
                s_imode = 1 & (1 ^ s_imode);
                break;
                }
        }       /* next key */
return (c);
}

tty_init()
{
#ifdef  DJGPP
extern  int __djgpp_set_ctrl_c();
__djgpp_set_ctrl_c(0);   /* test for Control-C via keyboard */
#endif
return  OK;
}

tty_set(int mode)
{
/*      normally this checks how to test for break-in */
return OK;
}

#ifdef DJGPP
/*      Use int 51 for mouse in dos box.
*       Simulate a 4-byte integer return similar to rxvt mouse
*       see Ralph Brown interrupt list for 0x33
* INT 33 - MS MOUSE v1.0+ - RETURN POSITION AND BUTTON STATUS
* AX = 0003h
* Return: BX = button status (see #1656)
* CX = column
* DX = row
* Note:in text modes, all coordinates are specified as multiples of the cell
*  size, typically 8x8 pixels
*  Bitfields for mouse button status:
*  Bit(s)	Description	(Table 1656)
*  0 left button pressed if 1
*  1 right button pressed if 1
*  2 middle button pressed if 1 (Mouse Systems/Logitech/Genius)
*/

int     xterm_mouse()
{
union   REGS    rx;
int     bs, cx, cy;
rx.x.ax = 3;
rx.x.bx = 0;
rx.x.cx = 0;
rx.x.dx = 0;
int86(0X33, &rx, &rx);
bs = rx.x.bx & 7;
if (bs == 0 ) return 0;
bs = (0 < (bs & 1))? 0 : (0 < (bs & 2)) ? 1 : (0 < (bs & 4)) ? 2 : 0;
cx = (int) rx.w.cx;
cy = (int) rx.w.dx;
return ((32+bs) | ('M')<< 8 | (33+cx/8)<<16 | (33+cy/8)<<24);
}
#endif






